<%@ Page Language="VB" %>
<%@ import Namespace="System.Data" %>
<%@ import Namespace="System.Data.Oledb" %>
<%@ import Namespace="GruveAccess" %>
<script runat="server">
Dim gLB As new GruveAccess.LinkDirectoryManager.Link()

'*******************************************************
'
' The Page_Load event
'
'*******************************************************

Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs)
	Dim sMode as String = Request("mode")
	Dim dtrResults as OledbDataReader

	gLB.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & Server.MapPath("../db/gruve.mdb") & ";"
	
	tblLinks.visible = false
	tblCategories.visible = false
	tblMenu.visible = false
	tblViewCategories.visible = false
	tblViewLinks.visible = false
	tblReciprocal.Visible = false
	tblInactive.Visible = false
	tblSearchResults.Visible = false

	If NOT IsPostBack	
		Select Case sMode
			Case "AddCategory"
				tblCategories.visible = true
				ddlSubCategory.Items.Add( New ListItem("TOP LEVEL CATEGORY", 0) )
				dtrResults = gLB.GetCategories(true,true)
				While dtrResults.Read()
					If dtrResults("iCategoryID") <> Request("id") Then
						ddlSubCategory.Items.Add( New ListItem(dtrResults("sCategory"), dtrResults("iCategoryID")) )
					End If
				End While
				dtrResults.Close()
				ddlSubCategory.SelectedValue= 0	
			Case "AddLink"
				tblLinks.visible = true
				ddlCategory.Datasource = gLB.GetCategories(true,false)
				ddlCategory.DataTextField = "sCategory"
				ddlCategory.DataValueField = "iCategoryID"
				ddlCategory.Databind()
			Case "ViewCategories"
				tblViewCategories.visible = true
				dgrdCategories.Datasource = gLB.GetCategories(false,true)
				dgrdCategories.Databind()
			Case "ViewLinks"
				tblViewLinks.visible = true
				ddlLinkCategory.Datasource = gLB.GetCategories(true,false)
				ddlLinkCategory.DataTextField = "sCategory"
				ddlLinkCategory.DataValueField = "iCategoryID"
				ddlLinkCategory.Databind()
				ddlLinkCategory.Items.Add( New ListItem("<-- Select Category for Links -->", 0) )
				ddlLinkCategory.SelectedValue = "0"
			Case "EditCategory"
				tblCategories.visible = true
				ddlSubCategory.Items.Add( New ListItem("TOP LEVEL CATEGORY", 0) )
				dtrResults = gLB.GetCategories(true,true)
				While dtrResults.Read()
					If dtrResults("iCategoryID") <> Request("id") Then
						ddlSubCategory.Items.Add( New ListItem(dtrResults("sCategory"), dtrResults("iCategoryID")) )
					End If
				End While
				dtrResults.Close()
				dtrResults = gLB.GetCategory(Request("id"))
				While dtrResults.Read()
					txtCategory.text = dtrResults("sCategory")
					chkActiveCategory.checked = dtrResults("bCategoryActive")
					ddlSubCategory.selectedvalue = dtrResults("iParentID")
					lblCategoryID.text = Request("id")
				End While
				dtrResults.Close()
			Case "EditLink"
				tblLinks.visible = true
				ddlCategory.Datasource = gLB.GetCategories(true,false)
				ddlCategory.DataTextField = "sCategory"
				ddlCategory.DataValueField = "iCategoryID"
				ddlCategory.Databind()				
				dtrResults = gLB.GetLink(Request("id"))
				lblLinkID.text = Request("id")
				While dtrResults.Read()
					txtTitle.text = dtrResults("sTitle")
					txtURL.text = dtrResults("sURL")
					txtDesc.text = dtrResults("sDesc")
					ddlCategory.SelectedValue = dtrResults("iCategoryID")
					txtReciprocal.text = dtrResults("sReciprocal")
					txtEmail.text = dtrResults("sEmail")
					txtComments.text = dtrResults("sComments")
					chkActiveLink.checked = dtrResults("bLinkActive")
				End While
				dtrResults.Close()
			Case "DeleteLink"
				gLB.DeleteLink(Request("id"))
				Response.Redirect("AdminLinks.aspx")			
			Case "Reciprocal"
				tblReciprocal.visible = true
				dgrdReciprocal.Datasource = gLB.GetNonReciprocalLinks(false)
				dgrdReciprocal.Databind()					
			Case "Inactive"
				tblInactive.visible = true
				dgrdInactive.Datasource = gLB.GetInactiveLinks()
				dgrdInactive.Databind()	
			Case Else
				tblMenu.visible = true
		End Select
	End If
	
End Sub

Sub OnBtnAddCategoryClicked (s As Object, e As EventArgs)
	Dim LB As new GruveAccess.LinkDirectoryManager.Link()
	Dim sTest as String

	gLB.SaveCategory(lblCategoryID.text,txtCategory.text,ddlSubCategory.SelectedValue,chkActiveCategory.checked)

	Server.Transfer("AdminLinks.aspx?mode=ViewCategories")

End Sub

Sub OnBtnSaveLinkClicked (s As Object, e As EventArgs)
	Dim LB As new GruveAccess.LinkDirectoryManager.Link()

	gLB.Title = txtTitle.text
	gLB.URL = txtURL.text
	gLB.Desc = txtDesc.text
	gLB.CategoryID = ddlCategory.selectedvalue
	gLB.Reciprocal = txtReciprocal.text
	gLB.Email = txtEmail.text
	gLB.Comments = txtComments.text
	gLB.LinkActive = chkActiveLink.checked
	gLB.SaveLink(lblLinkID.text)

	Response.Redirect("AdminLinks.aspx")

End Sub

Sub OnBtnSearchClicked (s As Object, e As EventArgs)
	Dim LB As new GruveAccess.LinkDirectoryManager.Link()

	tblSearchResults.Visible = true
	dgrdSearchResults.Datasource = gLB.SearchLinks(txtSearch.text)
	dgrdSearchResults.Databind()

End Sub

Sub OnLinksCategoryChanged (s As Object, e As EventArgs)
	Dim LB As new GruveAccess.LinkDirectoryManager.Link()

	tblViewLinks.visible = true
	dgrdLinks.Datasource = gLB.GetLinks(ddlLinkCategory.SelectedValue,false)
	dgrdLinks.Databind()

End Sub

Function GetSubCategories(iCategoryID as integer) as OledbDataReader
	Dim LB As new GruveAccess.LinkDirectoryManager.Link()

	Return gLB.GetSubCategories(iCategoryID,false)

End Function

Function CheckReciprocal(sLink as String) as String
	Dim sResult as String
	
	If sLink = "" Then
		sResult = "NONE"
	Else
		sResult = "Reciprocal"
	End If
	
	Return sResult
	
End Function
</script>
<html>
<head>
    <title>Link Manager</title>
    <META NAME="description" CONTENT="Find the Worlds most valuable and rarest collector cars, motorcycles, art, and more.">
    <META NAME="keywords" CONTENT="collector cars, exotic, antique, classic cars, hot rod, ferrari, mercedes, corvette, jaguar, vintage, celebrity cars, motorcycle, art, airplanes, auction, rare, collectible, restoration, nascar, harley davidson, values, price, for sale, classifieds, dealer">
    <META HTTP-EQUIV=Expires CONTENT="Mon, 06 Jan 1990 00:00:01 GMT">
	<SCRIPT LANGUAGE="javascript">
	<!--
	function deleteItem(ID,Title,Type)
	{
	var sMsg
	var iResponse

	sMsg = "Are you sure you want to DELETE '" + Title + "' "

	iResponse = window.confirm(sMsg)
	if (iResponse) 
	{
	window.document.location = "AdminLinks.aspx?mode=Delete" + Type + "&id=" + ID
	}
	}
	//-->
	</SCRIPT>
</head>
<body leftmargin="0" topmargin="0" rightmargin="0" bottommargin="0" marginheight="0" marginwidth="0">
	<form runat="server">
	<font face="verdana">
	<b>
	<center>
	<br><br>	
	<h1>Link Directory Manager Admin Tool</h1>
	<br>
	<center>
	<a href="AdminLinks.aspx">Return to Admin Menu</a>
	<br><br><br>	
	
	<table id="tblLinks" border="1" cellpadding="5" width="80%" align="center" runat="server">
		<tr>
			<td align="center" colspan="2">
			<h2>Link</h2>
			</td>
		</tr>
		<tr><td colspan="2">&nbsp;<asp:label id="lblLinkID" text="0" visible="false" runat="server"/></td></tr>		
		<tr>
			<td align="right">
				Title: 
			</td>
			<td>
				<asp:textbox id="txtTitle" size="75" maxlength="75" runat="server"/>
			</td>
		</tr>
		<tr>
			<td align="right">
				URL:
			</td>
			<td>
				<asp:textbox id="txtURL" size="75" maxlength="75" text="http://" runat="server"/>
			</td>
		</tr>		
		<tr>
			<td align="right">
				Description:
			</td>
			<td>
				<asp:textbox id="txtDesc" TextMode="MultiLine" rows="8" columns="60" runat="server"/>
			</td>
		</tr>	
		<tr>
			<td align="right">
				Category:
			</td>
			<td>
				<asp:dropdownlist id="ddlCategory" runat="server"/>
			</td>
		</tr>
		<tr>
			<td align="right">
				Reciprocal Link:
			</td>
			<td>
				<asp:textbox id="txtReciprocal" size="75" maxlength="75" runat="server"/>
			</td>
		</tr>		
		<tr>
			<td align="right">
				Email:
			</td>
			<td>
				<asp:textbox id="txtEmail" size="75" maxlength="75" runat="server"/>
			</td>
		</tr>		
		<tr>
			<td align="right">
				Comments:
			</td>
			<td>
				<asp:textbox id="txtComments" TextMode="MultiLine" rows="8" columns="60" runat="server"/>
			</td>
		</tr>
		<tr><td colspan="2">&nbsp;</td></tr>
		<tr>
			<td align="center" colspan="2">
				Active Link:
				<asp:checkbox id="chkActiveLink" checked="true" runat="server"/>
			</td>
		</tr>
		<tr><td colspan="2">&nbsp;</td></tr>
		<tr>
			<td align="center" colspan="2">
			<asp:button id="btnSaveLink" text="Save"  onclick="OnBtnSaveLinkClicked" runat="server"/>
			</td>
		</tr>		
	</table>


	<table id="tblCategories" border="1" cellpadding="5" width="80%" align="center" runat="server">
		<tr>
			<td align="center" colspan="2">
			<h2>Category</h2>
			</td>
		</tr>
		<tr>
			<td align="right">
				Category:
			</td>
			<td>
				<asp:textbox id="txtCategory" size="50"	maxlength="50" runat="server"/>
			</td>
		</tr>
		<tr><td colspan="2">&nbsp;<asp:label id="lblCategoryID" text="0" visible="false" runat="server"/></td></tr>
		<tr>
			<td align="right">
				Sub Category of:
			</td>
			<td>
				<asp:dropdownlist id="ddlSubCategory" runat="server"/>
			</td>
		</tr>
		<tr><td colspan="2">&nbsp;</td></tr>
		<tr>
			<td align="right">
				Active Category:
			</td>
			<td>
				<asp:checkbox id="chkActiveCategory" runat="server"/>
			</td>
		</tr>
		<tr><td colspan="2">&nbsp;</td></tr>
		<tr>
			<td align="center" colspan="2">
			<asp:button id="btnSaveCategory" onclick="OnBtnAddCategoryClicked" text="Save" runat="server"/>
			</td>
		</tr>
	</table>


	<table id="tblViewCategories" width="50%" align="center" runat="server">
		<tr>
			<td align="center" colspan="4">
			<h3>View/Edit Categories</h3>
			</td>
		</tr>
		<tr>
			<td align="center" colspan="4">
					<table width="100%">
						<asp:DataGrid ID="dgrdCategories" AutoGenerateColumns="False" GridLines="None" width="100%" Runat="Server" >
						<Columns>
						<asp:TemplateColumn>
							<headerTemplate>
								<tr bgcolor="red">
									<th width="40%" align="left">Category</th>
									<th width="20%" align="left">Sub-Category</th>
									<th width="20%" align="left">Active</th>
									<th width="20%" align="left">Edit</th>
								</tr>
							</headerTemplate>
							<itemTemplate>
								<tr>
									<td><%# Container.DataItem( "sCategory" )%></td>
									<td>&nbsp;</td>
									<td><%# Container.DataItem( "bCategoryActive" )%></td>
									<td><a href="AdminLinks.aspx?mode=EditCategory&id=<%# Container.DataItem( "iCategoryID" )%>">Edit</a></td>
								</tr>
								<tr>
									<td colspan="4">
									<table width="100%" align="right">
										<tr>
											<td align="right" width="100%">
											<asp:DataGrid ID="dgrdSubCategories" GridLines="None" AutoGenerateColumns="False" DataSource='<%# GetSubCategories(Container.DataItem( "iCategoryID" ))%>' width="80%" Runat="Server" >
												<Columns>
												<asp:TemplateColumn>
													<itemTemplate>
															<td align="left" width="15%">&nbsp;</td>
															<td align="left" width="30%"><%# Container.DataItem( "sCategory" )%></td>
															<td width="25%"><%# Container.DataItem( "bCategoryActive" )%></td>
															<td><a href="AdminLinks.aspx?mode=EditCategory&id=<%# Container.DataItem( "iCategoryID" )%>">Edit</a></td>
													</itemTemplate>
												</asp:TemplateColumn>
												</Columns>
											</asp:DataGrid>
											</td>
										</tr>
									</table>
									</td>
								</tr>					
							</itemTemplate>
							<footerTemplate>
						</table>
					</footerTemplate>								
				</asp:TemplateColumn>
				</Columns>
				</asp:DataGrid>
			</td>
		</tr>
		<tr><td colspan="2">&nbsp;</td></tr>
	</table>		


	<table id="tblViewLinks" width="70%" align="center" runat="server">
		<tr>
			<td align="center" colspan="2">
			<h3>View/Edit Links</h3>
			</td>
		</tr>		
		<tr>
			<td align="center" colspan="2">
				Select Category for Links:
				<asp:dropdownlist id="ddlLinkCategory" AutoPostBack="True" OnSelectedIndexChanged="OnLinksCategoryChanged" runat="server"/>
			</td>
		</tr>
		<tr><td colspan="2">&nbsp;</td></tr>		
		<tr>
			<td align="center" colspan="2">
				<asp:DataGrid ID="dgrdLinks" AutoGenerateColumns="False" GridLines="None" width="100%" Runat="Server" >
				<Columns>
				<asp:TemplateColumn>
					<headerTemplate>
					<table align="center" width="90%">
						<tr bgcolor="red">
							<th width="60%" align="left">Title</th>
							<th width="10%" align="left">Active</th>
							<th width="10%" align="left">Edit</th>
							<th width="10%" align="left">Delete</th>
						</tr>
					</headerTemplate>
					<itemTemplate>
					<tr>
						<td><%# Container.DataItem( "sTitle" )%></td>
						<td><%# Container.DataItem( "bLinkActive" )%></td>
						<td><a href="AdminLinks.aspx?mode=EditLink&id=<%# Container.DataItem( "iLinkID" )%>">Edit</a></td>
						<td><a href="javascript:deleteItem(<%# Container.DataItem( "iLinkID" )%>,'<%# Container.DataItem( "sTitle" )%>','Link')">Delete</a></td>
					</tr>
					</itemTemplate>
					<footerTemplate>
						</table>
					</footerTemplate>								
				</asp:TemplateColumn>
				</Columns>
				</asp:DataGrid>
			</td>
		</tr>
		<tr><td colspan="2">&nbsp;</td></tr>
	</table>


	<table id="tblReciprocal" width="70%" align="center" runat="server">
		<tr>
			<td align="center" colspan="2">
			<h3>Mark Reciprocal Links</h3>
			</td>
		</tr>		
		<tr><td colspan="2">&nbsp;</td></tr>		
		<tr>
			<td align="center" colspan="2">
				<asp:DataGrid ID="dgrdReciprocal" AutoGenerateColumns="False" GridLines="None" width="100%" Runat="Server" >
				<Columns>
				<asp:TemplateColumn>
					<headerTemplate>
					<table align="center" width="90%">
						<tr bgcolor="red">
							<th width="10%" align="left">Created</th>						
							<th width="70%" align="left">Title</th>
							<th width="15%" align="left">Active</th>
							<th width="15%" align="left">Edit</th>
							<th width="15%" align="left">Delete</th>
						</tr>
					</headerTemplate>
					<itemTemplate>
					<tr>
						<td><%# String.Format("{0:d}",Container.DataItem( "dLinkCreated" ))%></td>					
						<td><%# Container.DataItem( "sTitle" )%></td>
						<td><%# Container.DataItem( "bLinkActive" )%></td>
						<td><a href="AdminLinks.aspx?mode=EditLink&id=<%# Container.DataItem( "iLinkID" )%>">Edit</a></td>
						<td><a href="javascript:deleteItem(<%# Container.DataItem( "iLinkID" )%>,'<%# Container.DataItem( "sTitle" )%>','Link')">Delete</a></td>
					</tr>
					</itemTemplate>
					<footerTemplate>
						</table>
					</footerTemplate>								
				</asp:TemplateColumn>
				</Columns>
				</asp:DataGrid>
			</td>
		</tr>
		<tr><td colspan="2">&nbsp;</td></tr>
	</table>


	<table id="tblInactive" width="70%" align="center" runat="server">
		<tr>
			<td align="center" colspan="2">
			<h3>Inactive Links</h3>
			</td>
		</tr>		
		<tr><td colspan="2">&nbsp;</td></tr>		
		<tr>
			<td align="center" colspan="2">
				<asp:DataGrid ID="dgrdInactive" AutoGenerateColumns="False" GridLines="None" width="100%" Runat="Server" >
				<Columns>
				<asp:TemplateColumn>
					<headerTemplate>
					<table align="center" width="90%">
						<tr bgcolor="red">
							<th width="10%" align="left">Created</th>						
							<th width="70%" align="left">Title</th>
							<th width="15%" align="left">Active</th>
							<th width="15%" align="left">Edit</th>
							<th width="15%" align="left">Delete</th>
						</tr>
					</headerTemplate>
					<itemTemplate>
					<tr>
						<td><%# String.Format("{0:d}",Container.DataItem( "dLinkCreated" ))%></td>					
						<td><%# Container.DataItem( "sTitle" )%></td>
						<td><%# Container.DataItem( "bLinkActive" )%></td>
						<td><a href="AdminLinks.aspx?mode=EditLink&id=<%# Container.DataItem( "iLinkID" )%>">Edit</a></td>
						<td><a href="javascript:deleteItem(<%# Container.DataItem( "iLinkID" )%>,'<%# Container.DataItem( "sTitle" )%>','Link')">Delete</a></td>
					</tr>
					</itemTemplate>
					<footerTemplate>
						</table>
					</footerTemplate>								
				</asp:TemplateColumn>
				</Columns>
				</asp:DataGrid>
			</td>
		</tr>
		<tr><td colspan="2">&nbsp;</td></tr>
	</table>


	<table id="tblSearchResults" width="70%" align="center" runat="server">
		<tr>
			<td align="center" colspan="2">
			<h3>Search Result Links</h3>
			</td>
		</tr>		
		<tr><td colspan="2">&nbsp;</td></tr>		
		<tr>
			<td align="center" colspan="2">
				<asp:DataGrid ID="dgrdSearchResults" AutoGenerateColumns="False" GridLines="None" width="100%" Runat="Server" >
				<Columns>
				<asp:TemplateColumn>
					<headerTemplate>
					<table align="center" width="90%">
						<tr bgcolor="red">
							<th width="70%" align="left">Title</th>
							<th width="15%" align="left">Active</th>
							<th width="15%" align="left">Edit</th>
							<th width="15%" align="left">Reciprocal</th>							
							<th width="15%" align="left">Delete</th>
						</tr>
					</headerTemplate>
					<itemTemplate>
					<tr>
						<td><%# Container.DataItem( "sTitle" )%></td>
						<td><%# Container.DataItem( "bLinkActive" )%></td>
						<td><a href="AdminLinks.aspx?mode=EditLink&id=<%# Container.DataItem( "iLinkID" )%>">Edit</a></td>
						<td><a href="<%# Container.DataItem( "sReciprocal" )%>" target="_blank"><%# CheckReciprocal(Container.DataItem( "sReciprocal" ))%></a></td>
						<td><a href="javascript:deleteItem(<%# Container.DataItem( "iLinkID" )%>,'<%# Container.DataItem( "sTitle" )%>','Link')">Delete</a></td>
					</tr>
					</itemTemplate>
					<footerTemplate>
						</table>
					</footerTemplate>								
				</asp:TemplateColumn>
				</Columns>
				</asp:DataGrid>
			</td>
		</tr>
		<tr><td colspan="2">&nbsp;</td></tr>
	</table>


	<table id="tblMenu" border="1" width="50%" align="center" runat="server">
		<tr>
			<td align="center" colspan="2">
			<h2>Categories & Links Admin</h2>
			</td>
		</tr>
		<tr>
			<td align="center">
				<a href="AdminLinks.aspx?mode=AddCategory">Add New Category</a>
			</td>
			<td align="center">
				<a href="AdminLinks.aspx?mode=AddLink">Add New Link</a>
			</td>
		</tr>
		<tr>
			<td align="center">
				<a href="AdminLinks.aspx?mode=ViewCategories">View/Edit Categories</a>
			</td>
			<td align="center">
				<a href="AdminLinks.aspx?mode=ViewLinks">View/Edit Links</a>
			</td>
		</tr>
		<tr><td colspan="2">&nbsp;</td></tr>
		<tr>
			<td align="center" colspan="2">
			<h2>Regular Maintenance</h2>
			</td>
		</tr>
		<tr>
			<td align="center" colspan="2">
				<a href="AdminLinks.aspx?mode=Reciprocal">Links Awaiting Reciprocal Links</a>
			</td>
		</tr>			
		<tr>
			<td align="center" colspan="2">
				<a href="AdminLinks.aspx?mode=Inactive">Inactive Links needing Approval</a>
			</td>
		</tr>
	</table>
	<br><br><br>

	<table border="1" cellpadding="5">
		<tr>
			<td><b>Search Links:</b> <asp:textbox id="txtSearch" runat="server" /><asp:button id="btnSearch" text="Search" onclick="OnBtnSearchClicked" runat="server" /></td>
		</tr>
	</table>
	<br><br>
	
	<a href="../Links.aspx">Return to Site Link Directory</a>
	</center>	

	<br><br>
	</b>
	</font>
	</form>
</body>
</html>